///*****************************************
//  Copyright (C) 2009-2014
//  ITE Tech. Inc. All Rights Reserved
//  Proprietary and Confidential
///*****************************************
//   @file   <CS8953sfr.H>
//   @author Jau-chih.Tseng@ite.com.tw
//   @date   2012/06/29
//   @fileversion: IT626X_BASE_M1_MYSON_V206
//******************************************/

#ifndef __CS8953sfr_H__
#define __CS8953sfr_H__
/*--------------------------------------------------------------------------
  Defined registers
--------------------------------------------------------------------------*/

/*  BYTE Register  */
    sfr P0        = 0x80;   /* Port 0                                     */
    sfr SP        = 0x81;   /* Stack Pointer                              */
    sfr DPL       = 0x82;   /* Data Pointer 0 Low byte                    */
    sfr DPL0      = 0x82;
    sfr DPH       = 0x83;   /* Data Pointer 0 High byte                   */
    sfr DPH0      = 0x83;
    sfr DPL1      = 0x84;   /* Data Pointer 1 Low byte                    */
    sfr DPH1      = 0x85;   /* Data Pointer 1 High byte                   */
    sfr DPSEL     = 0x86;   /* Data pointers select                       */
    sfr PCON      = 0x87;   /* Power Configuration                        */

    sfr TCON      = 0x88;   /* Timer 0,1 Configuration                    */
    sfr TMOD      = 0x89;   /* Timer 0,1 Mode                             */
    sfr TL0       = 0x8A;   /* Timer 0 Low byte counter                   */
    sfr TL1       = 0x8B;   /* Timer 1 Low byte counter                   */
    sfr TH0       = 0x8C;   /* Timer 0 High byte counter                  */
    sfr TH1       = 0x8D;   /* Timer 1 High byte counter                  */
    sfr CKCON     = 0x8E;   /* XDATA Wait States                          */
    sfr CKSEL     = 0x8F;   /* CPU clock select                           */

    sfr P1        = 0x90;   /* Port 1                                     */
    sfr EXIF      = 0x91;   /* External Interrupt Flag                    */
    sfr WTST      = 0x92;   /* Program Wait States                        */
    sfr DPP       = 0x93;   /* Data Page Pointer 0 for A23~A16            */
    sfr DPX       = 0x93;
    sfr DPX0      = 0x93;
    sfr CMPST     = 0x94;   /* Comparator status register                 */
    sfr DPX1      = 0x95;   /* Data Page Pointer 1 for A23~A16            */
    sfr PINT0EN   = 0x96;   /* external Port INT0 enable register         */
    sfr PINT0FG   = 0x97;   /* external Port INT0 status register         */

    sfr SCON      = 0x98;   /* Serial 0 Configuration                     */
    sfr SCON0     = 0x98;
    sfr SBUF      = 0x99;   /* Serial 0 I/O Buffer                        */
    sfr SBUF0     = 0x99;
/*  sfr           = 0x9A;                                                 */
    sfr ESP       = 0x9B;   /* Extend Stack Pointer for A15~A8            */
/*  sfr           = 0x9C;                                                 */
    sfr ACON      = 0x9D;   /* Address Control FLAT/LARGE                 */
/*  sfr           = 0x9E;                                                 */
    sfr WKMASK    = 0x9F;   /* Wake up mask register                      */


    sfr P2        = 0xA0;   /* Port 2                                     */
/*  sfr SPICR     = 0xA1;                                                 */
/*  sfr SPIMR     = 0xA2;                                                 */
/*  sfr SPIST     = 0xA3;                                                 */
/*  sfr SPIDAT    = 0xA4;                                                 */
/*  sfr SFIFO2    = 0xA5;                                                 */
/*  sfr SBUF2     = 0xA6;                                                 */
/*  sfr SINT2     = 0xA7;                                                 */

    sfr IE        = 0xA8;   /* Interrupt Enable                           */
    sfr ADCCFG    = 0xA9;   /* ADC configuration rgister                  */
    sfr ADCDL     = 0xAA;   /* ADC channel D result low byte              */
    sfr ADCDH     = 0xAB;   /* ADC channel D result high byte             */
/*  sfr           = 0xAC;                                                 */
/*  sfr           = 0xAD;                                                 */
    sfr PINT1EN   = 0xAE;   /* external Port INT1 enable register         */
    sfr PINT1FG   = 0xAF;   /* external Port INT1 status register         */

    sfr P3        = 0xB0;   /* Port 3                                     */
/*  sfr           = 0xB1;                                                 */
    sfr CCAPM0    = 0xB2;   /* PCA module 0 configuration register        */
    sfr CCAPM1    = 0xB3;   /* PCA module 1 configuration register        */
    sfr CCAPM2    = 0xB4;   /* PCA module 2 configuration register        */
    sfr CCAPM3    = 0xB5;   /* PCA module 3 configuration register        */
    sfr CCAPM4    = 0xB6;   /* PCA module 4 configuration register        */
    sfr CCAPM5    = 0xB7;   /* PCA module 5 configuration register        */

    sfr IP        = 0xB8;   /* Interrupt priority                         */
    sfr ADCCHSL   = 0xB9;   /* ADC channel select and status              */
    sfr ADCAL     = 0xBA;   /* ADC channel A result low byte              */
    sfr ADCAH     = 0xBB;   /* ADC channel A result high byte             */
    sfr ADCBL     = 0xBC;   /* ADC channel B result low byte              */
    sfr ADCBH     = 0xBD;   /* ADC channel B result high byte             */
    sfr ADCCL     = 0xBE;   /* ADC channel C result low byte              */
    sfr ADCCH     = 0xBF;   /* ADC channel C result high byte             */

    sfr SCON1     = 0xC0;   /* Serial 1 Configuration                     */
    sfr SBUF1     = 0xC1;   /* Serial 1 I/O Buffer                        */
/*  sfr SCON2     = 0xC2;                                                 */
/*  sfr SBAUD2    = 0xC3;                                                 */
    sfr PMR       = 0xC4;   /* Power mode control register                */
    sfr STATUS    = 0xC5;   /* Interrupt or UART active status            */
    sfr MCON      = 0xC6;   /* On-chip XRAM relocation register           */
    sfr TA        = 0xC7;   /* Timed access A register                    */

    sfr T2CON     = 0xC8;   /* Timer 2 Configuration                      */
    sfr TB        = 0xC9;   /* Timed access B register                    */
//    sfr RLDL      = 0xCA;   /* Timer 2 Reload Low byte                    */
    sfr RCAP2L      = 0xCA;   /* Timer 2 Reload Low byte                    */
//    sfr RLDH      = 0xCB;   /* Timer 2 Reload High byte                   */
    sfr RCAP2H      = 0xCB;   /* Timer 2 Reload High byte                   */
    sfr TL2       = 0xCC;   /* Timer 2 low byte counter                   */
    sfr TH2       = 0xCD;   /* Timer 2 High byte counter                  */
/*  sfr           = 0xCE;                                                 */
/*  sfr           = 0xCF;                                                 */

    sfr PSW       = 0xD0;   /* Program Status Word                        */
    sfr CMOD      = 0xD1;   /* PCA mode control register                  */
    sfr CCAP0L    = 0xD2;   /* PCA ch0 compare, capture or PWM low byte   */
    sfr CCAP0H    = 0xD3;   /* PCA ch0 compare, capture or PWM high byte  */
    sfr CCAP1L    = 0xD4;   /* PCA ch1 compare, capture or PWM low byte   */
    sfr CCAP1H    = 0xD5;   /* PCA ch1 compare, capture or PWM high byte  */
    sfr CCAP2L    = 0xD6;   /* PCA ch2 compare, capture or PWM low byte   */
    sfr CCAP2H    = 0xD7;   /* PCA ch2 compare, capture or PWM high byte  */

    sfr WDCON     = 0xD8;   /* Watch dog control and status register      */
    sfr CL        = 0xD9;   /* PCA main counter low byte                  */
    sfr DPXR      = 0xDA;   /* MOVX @Ri optional high byte register       */
/*  sfr I2CSCON2  = 0xDB;                                                 */
/*  sfr I2CSST2   = 0xDC;                                                 */
/*  sfr I2CSADR2  = 0xDD;                                                 */
/*  sfr I2CSDAT2  = 0xDE;                                                 */
/*  sfr           = 0xDF;                                                 */

    sfr ACC       = 0xE0;   /* Accumulator                                */
    sfr CCON      = 0xE1;   /* PCA control register                       */
    sfr CCAP3L    = 0xE2;   /* PCA ch3 compare, capture or PWM low byte   */
    sfr CCAP3H    = 0xE3;   /* PCA ch3 compare, capture or PWM high byte  */
    sfr CCAP4L    = 0xE4;   /* PCA ch4 compare, capture or PWM low byte   */
    sfr CCAP4H    = 0xE5;   /* PCA ch4 compare, capture or PWM high byte  */
    sfr CCAP5L    = 0xE6;   /* PCA ch5 compare, capture or PWM low byte   */
    sfr CCAP5H    = 0xE7;   /* PCA ch5 compare, capture or PWM high byte  */

    sfr EXIE      = 0xE8;   /* External interrupt enable                  */
    sfr CH        = 0xE9;   /* PCA main counter high byte                 */
    sfr MXAX      = 0xEA;   /* MOVX @Ri High address for A23~A16          */
    sfr I2CSCON1  = 0xEB;   /* Slave I2C control register                 */
    sfr I2CSST1   = 0xEC;   /* Slave I2C control register                 */
    sfr I2CSADR1  = 0xED;   /* Slave I2C device address                   */
    sfr I2CSDAT1  = 0xEE;   /* Slave I2C data buffer                      */
/*  sfr           = 0xEF;                                                 */

    sfr B         = 0xF0;   /* B Working register                         */
/*  sfr           = 0xF1;                                                 */
/*  sfr           = 0xF2;                                                 */
/*  sfr           = 0xF3;                                                 */
    sfr I2CMSA    = 0xF4;   /* I2CM Slave Address                         */
    sfr I2CMCR    = 0xF5;   /* I2CM Control Register                      */
    sfr I2CMBUF   = 0xF6;   /* I2CM I/O Buffer                            */
    sfr I2CMTP    = 0xF7;   /* I2CM Timer Period                          */

    sfr EXIP      = 0xF8;   /* External Interr. Priority                  */
    sfr MD0       = 0xF9;   /* MDU Data 0                                 */
    sfr MD1       = 0xFA;   /* MDU Data 1                                 */
    sfr MD2       = 0xFB;   /* MDU Data 2                                 */
    sfr MD3       = 0xFC;   /* MDU Data 3                                 */
    sfr MD4       = 0xFD;   /* MDU Data 4                                 */
    sfr MD5       = 0xFE;   /* MDU Data 5                                 */
    sfr ARCON     = 0xFF;   /* MDU Control                                */



/*-------------------------------------------------------------------------
  BIT Register
  -------------------------------------------------------------------------*/

/*  P0    */
    sbit P0_7     = P0^7;
    sbit P0_6     = P0^6;
    sbit P0_5     = P0^5;
    sbit P0_4     = P0^4;
    sbit P0_3     = P0^3;
    sbit P0_2     = P0^2;
    sbit P0_1     = P0^1;
    sbit P0_0     = P0^0;

/*  P1    */
    sbit P1_7     = P1^7;
    sbit P1_6     = P1^6;
    sbit P1_5     = P1^5;
    sbit P1_4     = P1^4;
    sbit P1_3     = P1^3;
    sbit P1_2     = P1^2;
    sbit P1_1     = P1^1;
    sbit P1_0     = P1^0;

/*  P2    */
    sbit P2_7     = P2^7;
    sbit P2_6     = P2^6;
    sbit P2_5     = P2^5;
    sbit P2_4     = P2^4;
    sbit P2_3     = P2^3;
    sbit P2_2     = P2^2;
    sbit P2_1     = P2^1;
    sbit P2_0     = P2^0;

/*  P3    */
    sbit P3_7     = P3^7;
    sbit P3_6     = P3^6;
    sbit P3_5     = P3^5;
    sbit P3_4     = P3^4;
    sbit P3_3     = P3^3;
    sbit P3_2     = P3^2;
    sbit P3_1     = P3^1;
    sbit P3_0     = P3^0;

/*  TCON  */
    sbit IT0      = TCON^0;
    sbit IE0      = TCON^1;
    sbit IT1      = TCON^2;
    sbit IE1      = TCON^3;
    sbit TR0      = TCON^4;
    sbit TF0      = TCON^5;
    sbit TR1      = TCON^6;
    sbit TF1      = TCON^7;

/*  SCON0 */
    sbit RI0      = SCON0^0;
    sbit TI0      = SCON0^1;
    sbit RB08     = SCON0^2;
    sbit TB08     = SCON0^3;
    sbit REN0     = SCON0^4;
    sbit SM02     = SCON0^5;
    sbit SM01     = SCON0^6;
    sbit SM00     = SCON0^7;

/*  SCON  */
    sbit RI       = SCON0^0;
    sbit TI       = SCON0^1;
    sbit RB8      = SCON0^2;
    sbit TB8      = SCON0^3;
    sbit REN      = SCON0^4;
    sbit SM2      = SCON0^5;
    sbit SM1      = SCON0^6;
    sbit SM0      = SCON0^7;


/*  SCON1 */
    sbit RI1      = SCON1^0;
    sbit TI1      = SCON1^1;
    sbit RB18     = SCON1^2;
    sbit TB18     = SCON1^3;
    sbit REN1     = SCON1^4;
    sbit SM12     = SCON1^5;
    sbit SM11     = SCON1^6;
    sbit SM10     = SCON1^7;

/*  PSW   */
    sbit P        = PSW^0;
    sbit F1       = PSW^1;
    sbit OV       = PSW^2;
    sbit RS0      = PSW^3;
    sbit RS1      = PSW^4;
    sbit F0       = PSW^5;
    sbit AC       = PSW^6;
    sbit CY       = PSW^7;

/*  IE    */
    sbit EX0      = IE^0;
    sbit ET0      = IE^1;
    sbit EX1      = IE^2;
    sbit ET1      = IE^3;
    sbit ES0      = IE^4;
    sbit ET2      = IE^5;
    sbit ES1      = IE^6;
    sbit EA       = IE^7;

/*  IP    */
    sbit PX0      = IP^0;
    sbit PT0      = IP^1;
    sbit PX1      = IP^2;
    sbit PT1      = IP^3;
    sbit PS0      = IP^4;
    sbit PS       = IP^4;
    sbit PT2      = IP^5;
    sbit PS1      = IP^6;

/*  T2CON */
    sbit TF2      = T2CON^7;
    sbit EXF2     = T2CON^6;
    sbit RCLK     = T2CON^5;
    sbit TCLK     = T2CON^4;
    sbit EXEN2    = T2CON^3;
    sbit TR2      = T2CON^2;
    sbit CT2      = T2CON^1;
    sbit CPRL2    = T2CON^0;


/*  EXIE  */
    sbit EI2CM    = EXIE^0;
    sbit EINT2    = EXIE^1;
    sbit EINT3    = EXIE^2;
    sbit EINT4    = EXIE^3;
    sbit EWDI     = EXIE^4;
    sbit EINT6    = EXIE^5;
    sbit EINT7    = EXIE^6;
    sbit EINT8    = EXIE^7;

/*  EXIP  */
    sbit EI2CMP   = EXIP^0;
    sbit EINT2P   = EXIP^1;
    sbit EINT3P   = EXIP^2;
    sbit EINT4P   = EXIP^3;
    sbit EWDIP    = EXIP^4;
    sbit EINT6P   = EXIP^5;
    sbit EINT7P   = EXIP^6;
    sbit EINT8P   = EXIP^7;

/*  WDCON */
    sbit RWT      = WDCON^0; // WDCON
    sbit EWT      = WDCON^1;
    sbit WTRF     = WDCON^2;
    sbit WDIF     = WDCON^3;


#endif


